<?php
namespace Teknisa\SUP\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class SearchAgrupamentoArvore extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "search_agrupamentoarvoredemanda";
    protected $dataSourceManager;
    protected $environment;

    public function __construct($crudService, $parameterBag, $dataSourceManager, $environment) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }

    public function SearchAgrupamentoArvore(Request\Filter $request, Response $response) {
        try {
            $onDemandFilter = $request->getFilterCriteria();
            $conditions = $onDemandFilter->getConditions();

            if (end($conditions)['columnName'] !== 'NRARVOREPRODPAI') {
                if (end($conditions)['operator'] == 'LIKE_ALL') {
                    $filter = end($conditions)['value'];
                    $newConditions = array(
                        array(
                            "columnName" => "FILTER",
                            "operator" => "=",
                            "value" => $filter
                        )
                    );
                    $onDemandFilter = new FilterCriteria('search_agrupamentoarvorefilter', $newConditions);
                }
                else {
                    $onDemandFilter->addCondition('NRARVOREPRODPAI', 'IS_NULL', '');
                    $onDemandFilter->setDataSourceName($this->dataSourceName);
                }
            } else {
                $onDemandFilter->setDataSourceName($this->dataSourceName);
            }
            $onDemandFilter->addCondition("NRORG", $this->environment->getNrOrg());
            $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($onDemandFilter, array());
            $dataSource = $this->dataSourceManager->findBy($newFilterCriteria);
            $dataSet = self::montaDataSet($dataSource->getRows());
            $response->addDataSet(new DataSet('/searchAgrupamentoArvoreDemanda', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }


    public function montaDataSet(array $dataSource) {
        $dataSet = array();
        
        foreach($dataSource as $data){
            array_push($dataSet, array(
                'NRTPARVPROD'     => $data['NRTPARVPROD'],
                'NRARVOREPROD'    => $data['NRARVOREPROD'],
                'NRARVOREPRODPAI' => $data['NRARVOREPRODPAI'],
                'NMARVOREPROD'    => $data['NMARVOREPROD'],
                'NRORG'           => $data['NRORG'],
                '_hasChild'       => $data['PAI'] === 'true' ? true : false
            ));
        }
        return $dataSet;
    }
}