<?php
namespace Teknisa\SUP\Modules\Cadastros\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;


class CentraldeComprasController extends \Teknisa\GER\Controllers\TeknisaCrud 
{

    protected $dataSourceName = "cmp01500_central_de_compras";
	
	public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }

	public function removeDependencia(DTO\Request $request, DTO\Response $response) {
		$data = $request->getDataSet()->getRows();

        $query = 'UPDATE FILIAL SET CDFILCENTCMP = NULL WHERE CDFILIAL = :CDFILIAL';
        $stmt = $this->con->prepare($query);
        $stmt->execute(array(
            "CDFILIAL" => $data[0]['CDFILIAL']
        ));
	}
	
    public function salvaDependencia(DTO\Request $request, DTO\Response $response) {
    
        try{
		    $data = $request->getDataSet()->getRows();
		
	    	if($data[0]['CDFILIAL'] == $data[0]['CDFILCENTCMP']){
	    	    throw new \Exception('Filial informada deve ser diferente da central de compras');    
	    	}
    
            $query = 'UPDATE FILIAL SET CDFILCENTCMP = :CDFILCENTCMP WHERE CDFILIAL = :CDFILIAL';
            $stmt = $this->con->prepare($query);
            $stmt->execute(array(
                "CDFILCENTCMP" => $data[0]['CDFILCENTCMP'],
                "CDFILIAL" => $data[0]['CDFILIAL']
            ));
        } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
	}
}