<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\Pedido\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\SUP\Util\SupUtilities;

class ControlePedidoColetaInternet extends \Teknisa\GER\Controllers\TeknisaCrud
{

    protected $crudService;
    protected $controlePedidoColetaInternetService;
    protected $controlePedidoColetaAceiteService;
    protected $controlePedidoColetaService;
    protected $dataSourceManager;
    protected $smtpUtil;
    protected $entityManager;
    protected $zhFileUploader;
    protected $fileServerURL;
    protected $supUtilities;

    public function __construct($crudService, $parameterBag, $controlePedidoColetaInternetService, $controlePedidoColetaAceiteService, $controlePedidoColetaService, $dataSourceManager, $smtpUtil, EntityManager $entityManager, $zhFileUploader, $fileServerURL, SupUtilities $supUtilities) 
    {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->controlePedidoColetaInternetService = $controlePedidoColetaInternetService;
        $this->controlePedidoColetaAceiteService = $controlePedidoColetaAceiteService;
        $this->controlePedidoColetaService = $controlePedidoColetaService;
        $this->dataSourceManager = $dataSourceManager;
        $this->smtpUtil = $smtpUtil;
        $this->entityManager = $entityManager;
        $this->templatesDir = realpath(__DIR__ . '/../../../../../Util/Template');
        $this->zhFileUploader    = $zhFileUploader;
        $this->fileServerURL     = $fileServerURL;
        $this->supUtilities = $supUtilities;
    }
    
    //Atualizacao para Aprovação do Pedido de Coleta em Massa
    public function verificaUtilizaAprovacaoMassa(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        try {
            //Primeira coisa é ver qual o parâmetro está setado na Tela Dados Fornecedor/Ecommerce no campo Utiliza Aprovação de PedCol em Massa
            //Caso Não - Bloquear Ação se tiver mais de um pedido
            //Caso Apenas Gerentes ou Compradores - Verificar user
            //Caso Ambos - Verificar
            
            
           $paramUsaApMassa = $this->controlePedidoColetaInternetService->selectUtilizaAprovMassa($row[0]['CDFILIAL']);
           
           //$gerente é 1 caso true e 0 caso false
           $gerente = $this->controlePedidoColetaInternetService->selectEGerente($row[0]['OPERADORLOGADO']);
           
           //Verifica se o operador é o comprador dos pedidos a serem aceitos
           $comprador = true;
           foreach ($row as $pedido){
                
               if($pedido['CDOPERLANC'] != $row[0]['OPERADORLOGADO']){
                   $comprador = false;
               }
           }

           switch ($paramUsaApMassa){
               case "N":
                   //Verificar quantos pedidos chegaram
                   if(count($row) == 1){
                       //se for 1 OK
                       $response->addMessage(new DTO\Response\Message('OK'));
                   }else{
                       //se for maior que 1 erro
                       $response->addMessage(new DTO\Response\Message('ERROR_1'));
                   }
                break;
                case "A":
                    if($gerente == "1" || $comprador){
                        $response->addMessage(new DTO\Response\Message('OK'));
                    }else{
                        $response->addMessage(new DTO\Response\Message('ERROR'));
                    }
                break;
                case "G":
                    //verifica se é gerente
                    if($gerente == "1"){
                        $response->addMessage(new DTO\Response\Message('OK'));
                    }else{
                        $response->addMessage(new DTO\Response\Message('ERROR'));
                    }
                break;
                case "C":
                    if($comprador){
                        $response->addMessage(new DTO\Response\Message('OK'));
                    }else{
                        $response->addMessage(new DTO\Response\Message('ERROR'));
                    }
                break;
           }
          
           
           //$response->addMessage(new DTO\Response\Message('Teste'));
		} catch (\Exception $e) {
		   $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(),500));
		}
    }

}