<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\Pedido\Services;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource;
use Teknisa\Model\Suprimentos\Entities\Prmarcpedcol;
use Teknisa\Model\Suprimentos\Entities\Itempedcol;
use Teknisa\Model\Suprimentos\Entities\Pedcolgeral;
use Teknisa\Model\Geral\Entities\Lista;
use Teknisa\SUP\Util\SupUtilities;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class ControlePedidoColetaInternetService {

    protected $entityManager;
    protected $environment;
    protected $dataSourceManager;
    protected $newCode;
    protected $smtpUtil;
    protected $supUtilities;
    protected $fileServerURL;
    protected $crudService;

    public function __construct(EntityManager $entityManager, $environment, DataSource\Manager $dataSourceManager, $newCode, $smtpUtil, SupUtilities $supUtilities, $fileServerURL, $crudService)
    {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->dataSourceManager = $dataSourceManager;
        $this->newCode = $newCode;
        $this->smtpUtil = $smtpUtil;
        $this->supUtilities = $supUtilities;
        $this->fileServerURL = $fileServerURL;
        $this->crudService = $crudService;
    }

    public function iniciaTransacao(){
        $this->entityManager->beginTransaction();
    }

    public function commit(){
        $this->entityManager->commit();
    }

    public function flush(){
        $this->entityManager->flush();
    }

    public function rollback(){
        $this->entityManager->rollback();
    }
    
    public function validatePassword($operador, $password) 
    {
		$dataSourceName = 'operador';
		$conditions = array(
			array(
				'columnName' => 'CDOPERADOR',
				'operator' => '=',
				"value" => $operador
			)
		);

		$dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
		
		if (md5($password) != $dataSet[0]['CDSENHAOPERWEB']) {
			throw new \Exception("SENHA_INVALIDA", 1);
		} else {
		    return true;
		}
	}
	
	public function selectUtilizaAprovMassa($cdfilial) {
        
        $query = "SELECT IDUTLAPROVMASSA FROM PARAMGERALECOMMERCE WHERE CDFILIAL = :P_CDFILIAL AND NRORG = :NRORG";

        $params = [
            "P_CDFILIAL" => $cdfilial,
            "NRORG" => $this->environment->getNrOrgTrab()
        ];

        $std = $this->entityManager->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll()[0]['IDUTLAPROVMASSA'];
    }
    
    public function selectEGerente($cdoperador) {
        
        $query = "select count (*) LINHAS from GERENTE WHERE CDOPERADOR = :P_CDOPERADOR AND NRORG = :NRORG";

        $params = [
            "P_CDOPERADOR" => $cdoperador,
            "NRORG" => $this->environment->getNrOrgTrab()
        ];

        $std = $this->entityManager->getConnection()->prepare($query);
        $std->execute($params);
        return $std->fetchAll()[0]['LINHAS'];
    }
	
    
}